//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  Google Chrome uEURg[ CEF4DelphĩeXg
//  }EX̃CxgXi[̊{eXg
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  2017N0301 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//  CEF4Delphi 3.3359.1768
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

{$I cef.inc}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, uCEFChromium, ComCtrls, uCEFWindowParent,
  uCEFInterfaces, uCEFTypes, uCEFConstants, uCEFv8Handler, uCEFProcessMessage,
  uCEFv8Context;

type
  TTestExtension = class
    class procedure mouseover(const data: string);
  end;

  TForm1 = class(TForm)
    CEFWindowParent1: TCEFWindowParent;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    Button1: TButton;
    Chromium1: TChromium;
    Timer1: TTimer;
    Label1: TLabel;    procedure FormCreate(Sender: TObject);
    procedure Chromium1AfterCreated(Sender: TObject;
      const browser: ICefBrowser);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Chromium1Close(Sender: TObject; const browser: ICefBrowser;
      out Result: Boolean);
    procedure Chromium1BeforeClose(Sender: TObject; const browser: ICefBrowser);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Chromium1AddressChange(Sender: TObject;
      const browser: ICefBrowser; const frame: ICefFrame; const url: ustring);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Chromium1ProcessMessageReceived(Sender: TObject;
      const browser: ICefBrowser; sourceProcess: TCefProcessId;
      const message: ICefProcessMessage; out Result: Boolean);
  private
    { Private 錾 }
    FCanClose   : boolean;
    FClosing    : boolean;
    procedure BrowserCreatedMsg(var aMessage : TMessage); message CEF_AFTERCREATED;
    procedure BrowserDestroyMsg(var aMessage : TMessage); message CEF_DESTROY;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

procedure GlobalCEFApp_OnWebKitInitialized;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := 'http://mrxray.on.coocan.jp/index.htm';

  Chromium1.CreateBrowser(CEFWindowParent1, '');
  FCanClose := False;
  FClosing  := False;
end;

//-----------------------------------------------------------------------------
//  ȉCtH[̐I܂ł̊֌W
//  CEF4Delphi 3.3359.1768.g8e7c5d6 ݗp
//
//  TTimer̃vpeB͈ȉ̒lɂĂ
//  TTimer.Enabled := False;
//  TTimer.Interval := 300;
//
//  ICefBrowser̃C^[tFCX̎gpɂusesuCEFInterfacesKv
//  萔̎gpɂusesuCEFConstantsKv
//-----------------------------------------------------------------------------
procedure TForm1.Chromium1AfterCreated(Sender: TObject;
  const browser: ICefBrowser);
begin
  PostMessage(Handle, CEF_AFTERCREATED, 0, 0)
end;

//-----------------------------------------------------------------------------
procedure TForm1.BrowserCreatedMsg(var aMessage: TMessage);
begin
  CEFWindowParent1.UpdateSize;
  Chromium1.LoadURL(Trim(Edit1.Text));
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormShow(Sender: TObject);
begin
  //('ł');

  //  WebRTCIP[N
  //  ڍׂ https://www.browserleaks.com/webrtc Q
  Chromium1.WebRTCIPHandlingPolicy := hpDisableNonProxiedUDP;
  Chromium1.WebRTCMultipleRoutes   := STATE_DISABLED;
  Chromium1.WebRTCNonproxiedUDP    := STATE_DISABLED;

  //ĂȂꍇ̓^C}[gpČŃuEU𐶐
  if not(Chromium1.CreateBrowser(CEFWindowParent1, '')) then Timer1.Enabled := True;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := FCanClose;

  if not(FClosing) then begin
    FClosing := True;
    Visible  := False;
    Chromium1.CloseBrowser(True);
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
//
end;

//-----------------------------------------------------------------------------
procedure TForm1.Chromium1BeforeClose(Sender: TObject;
  const browser: ICefBrowser);
begin
  if (Chromium1.BrowserId = 0) then begin
    FCanClose := True;
    PostMessage(Handle, WM_CLOSE, 0, 0);
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Chromium1Close(Sender: TObject; const browser: ICefBrowser;
  out Result: Boolean);
begin
  if (browser <> nil) and (Chromium1.BrowserId = browser.Identifier) then begin
    PostMessage(Handle, CEF_DESTROY, 0, 0);
    Result := True;
  end else begin
    Result := False;
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.BrowserDestroyMsg(var aMessage: TMessage);
begin
  CEFWindowParent1.Free;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  if not(Chromium1.CreateBrowser(CEFWindowParent1, ''))
    and not(Chromium1.Initialized) then begin
    Timer1.Enabled := True;
  end;
end;
//-----------------------------------------------------------------------------
//  tH[ƏȈ֌WR[hD܂
//-----------------------------------------------------------------------------


//=============================================================================
//  Chromium1OnAddressChangeCxg
//  ύXꂽEFuy[W̃AhXEdit1ɕ\
//=============================================================================
procedure TForm1.Chromium1AddressChange(Sender: TObject;
  const browser: ICefBrowser; const frame: ICefFrame; const url: ustring);
begin
  Edit1.Text := url;
end;

//=============================================================================
//  Edit1OnKeyDownCxg
//  [Enter]L[Edit1URL\
//=============================================================================
procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    Chromium1.LoadURL(Trim(Edit1.Text));
  end;
end;

//=============================================================================
//  Õy[WɈړ
//=============================================================================
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Chromium1.GoBack;
end;

//-----------------------------------------------------------------------------
//  TTestExtensionNX̓o^
//  vWFNg̃R[h(DPR)ňȉ̃_̐ݒĂ
//  TTestExtensionbZ[WCvZXɑMł悤ɂȂ
//  GlobalCEFApp.OnWebKitInitialized := GlobalCEFApp_OnWebKitInitialized;
//
//  usesuCEFv8HandlerKv
//-----------------------------------------------------------------------------
procedure GlobalCEFApp_OnWebKitInitialized;
begin
  TCefRTTIExtension.Register('myextension', TTestExtension);
end;

//=============================================================================
//  }EX̃CxgXi[JavaScriptœo^
//  }EXJ[\ʒũ^O܂̓N擾
//  t[ɂ͖Ή̃R[h
//  sʂTChromium.OnProcessMessageReceivedCxgŎ󂯎
//  \y[Wςēxo^Kv
//
//  Iɓo^ɂ́CႦTChromium.OnLoadEndCxgŎs
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LScriptText : string;
begin
  if (Chromium1.Browser = nil) or (Chromium1.Browser.MainFrame = nil) then exit;

  LScriptText := 'document.body.addEventListener("mouseover", function(evt){'
               + 'function getpath(n){'
               + '  if (n.nodeName === "A") {'
               + '    return n.href }'
               + '    else {'
               + '    return "<" + n.nodeName + ">"'
               + '  };'
               +'};'
               + 'myextension.mouseover(getpath(evt.target))'
               +'}'
               + ')';

  //JavaScript̎s
  Chromium1.Browser.MainFrame.ExecuteJavaScript(LScriptText, 'about:blank', 0);
end;

//=============================================================================
//  Chromium1OnProcessMessageReceivedCxg
//  _̃vZX̃bZ[WM
//  bZ[W󂯎KvȂ΂̃Cxg͕sv
//=============================================================================
procedure TForm1.Chromium1ProcessMessageReceived(Sender: TObject;
  const browser: ICefBrowser; sourceProcess: TCefProcessId;
  const message: ICefProcessMessage; out Result: Boolean);
begin
  Result := False;
  if (message = nil) or (message.ArgumentList = nil) then Exit;

  if (message.Name = 'mouseover') then begin
    Label1.Caption := message.ArgumentList.GetString(0);
    Result := True;
  end;
end;

{ TTestExtension }

//-----------------------------------------------------------------------------
//  _̃bZ[WCvZXɑM
//  TCefv8ContextRef.CurrentJavascriptsĂt[v8ReLXg
//
//  usesuCEFv8Context,uCEFProcessMessageKv
//  萔̎gpɂusesuCEFConstantsKv
//-----------------------------------------------------------------------------
class procedure TTestExtension.mouseover(const data: string);
var
  LMsg: ICefProcessMessage;
begin
  LMsg := TCefProcessMessageRef.New('mouseover');
  LMsg.ArgumentList.SetString(0, data);

  TCefv8ContextRef.Current.Browser.SendProcessMessage(PID_BROWSER, LMsg);
end;

end.
