//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  Google Chrome uEURg[ CEF4DelphĩeXg
//  JavaScript R[hɂVONH[e[Vƃ_uNH[e[V
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  2017N0301 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//  CEF4Delphi 3.3359.1768
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

{$I cef.inc}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, uCEFChromium, ComCtrls, uCEFWindowParent,
  uCEFInterfaces, uCEFTypes, uCEFConstants, uCEFv8Handler, uCEFProcessMessage,
  uCEFv8Context;

type
  TForm1 = class(TForm)
    CEFWindowParent1: TCEFWindowParent;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    Button1: TButton;
    Chromium1: TChromium;
    Timer1: TTimer;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;    procedure FormCreate(Sender: TObject);
    procedure Chromium1AfterCreated(Sender: TObject;
      const browser: ICefBrowser);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Chromium1Close(Sender: TObject; const browser: ICefBrowser;
      out Result: Boolean);
    procedure Chromium1BeforeClose(Sender: TObject; const browser: ICefBrowser);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Chromium1AddressChange(Sender: TObject;
      const browser: ICefBrowser; const frame: ICefFrame; const url: ustring);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Chromium1ConsoleMessage(Sender: TObject;
      const browser: ICefBrowser; level: Cardinal; const message,
      source: ustring; line: Integer; out Result: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private 錾 }
    FCanClose   : boolean;
    FClosing    : boolean;
    FJSFuncName : string;
    procedure BrowserCreatedMsg(var aMessage : TMessage); message CEF_AFTERCREATED;
    procedure BrowserDestroyMsg(var aMessage : TMessage); message CEF_DESTROY;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := 'http://mrxray.on.coocan.jp/index.htm';

  Chromium1.CreateBrowser(CEFWindowParent1, '');
  FCanClose := False;
  FClosing  := False;
end;

//-----------------------------------------------------------------------------
//  ȉCtH[̐I܂ł̊֌W
//  CEF4Delphi 3.3359.1768.g8e7c5d6 ݗp
//
//  TTimer̃vpeB͈ȉ̒lɂĂ
//  TTimer.Enabled := False;
//  TTimer.Interval := 300;
//
//  ICefBrowser̃C^[tFCX̎gpɂusesuCEFInterfacesKv
//  萔̎gpɂusesuCEFConstantsKv
//-----------------------------------------------------------------------------
procedure TForm1.Chromium1AfterCreated(Sender: TObject;
  const browser: ICefBrowser);
begin
  PostMessage(Handle, CEF_AFTERCREATED, 0, 0)
end;

//-----------------------------------------------------------------------------
procedure TForm1.BrowserCreatedMsg(var aMessage: TMessage);
begin
  CEFWindowParent1.UpdateSize;
  Chromium1.LoadURL(Trim(Edit1.Text));
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormShow(Sender: TObject);
begin
  //('ł');

  //  WebRTCIP[N
  //  ڍׂ https://www.browserleaks.com/webrtc Q
  Chromium1.WebRTCIPHandlingPolicy := hpDisableNonProxiedUDP;
  Chromium1.WebRTCMultipleRoutes   := STATE_DISABLED;
  Chromium1.WebRTCNonproxiedUDP    := STATE_DISABLED;

  //ĂȂꍇ̓^C}[gpČŃuEU𐶐
  if not(Chromium1.CreateBrowser(CEFWindowParent1, '')) then Timer1.Enabled := True;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := FCanClose;

  if not(FClosing) then begin
    FClosing := True;
    Visible  := False;
    Chromium1.CloseBrowser(True);
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
//
end;

//-----------------------------------------------------------------------------
procedure TForm1.Chromium1BeforeClose(Sender: TObject;
  const browser: ICefBrowser);
begin
  if (Chromium1.BrowserId = 0) then begin
    FCanClose := True;
    PostMessage(Handle, WM_CLOSE, 0, 0);
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Chromium1Close(Sender: TObject; const browser: ICefBrowser;
  out Result: Boolean);
begin
  if (browser <> nil) and (Chromium1.BrowserId = browser.Identifier) then begin
    PostMessage(Handle, CEF_DESTROY, 0, 0);
    Result := True;
  end else begin
    Result := False;
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.BrowserDestroyMsg(var aMessage: TMessage);
begin
  CEFWindowParent1.Free;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  if not(Chromium1.CreateBrowser(CEFWindowParent1, ''))
    and not(Chromium1.Initialized) then begin
    Timer1.Enabled := True;
  end;
end;
//-----------------------------------------------------------------------------
//  tH[ƏȈ֌WR[hD܂
//-----------------------------------------------------------------------------


//=============================================================================
//  Chromium1OnAddressChangeCxg
//  ύXꂽEFuy[W̃AhXEdit1ɕ\
//=============================================================================
procedure TForm1.Chromium1AddressChange(Sender: TObject;
  const browser: ICefBrowser; const frame: ICefFrame; const url: ustring);
begin
  Edit1.Text := url;
end;

//=============================================================================
//  Edit1OnKeyDownCxg
//  [Enter]L[Edit1URL\
//=============================================================================
procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    Chromium1.LoadURL(Trim(Edit1.Text));
  end;
end;

//=============================================================================
//  Õy[WɈړ
//=============================================================================
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Chromium1.GoBack;
end;

//=============================================================================
//  JavaScript̎s
//  FJSFuncName̓O[oϐ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LStrList : TStringList;
  LJsFunc  : string;
begin
  LStrList := TStringList.Create;
  try
    LStrList.LoadFromFile(ExpandFileName('.\Test_JS1.txt'));
    //JavaScript̃R[hZbg
    Chromium1.ExecuteJavaScript(LStrList.Text, 'about:blank');

    //s֐
    //OnConsoleMessageCxgł͂̒lŏ𕪊򂷂
    FJSFuncName := 'get_array';

    //JavaScript̊֐s
    //߂l̏o͐console.log
    LJsFunc := 'console.log(' + FJSFuncName + ' (""))';
    Chromium1.Browser.MainFrame.ExecuteJavaScript(LJsFunc, 'about:blank', 0);
  finally
    FreeAndNil(LStrList);
  end;
end;

//=============================================================================
//  JavaScript̎s
//  FJSFuncName̓O[oϐ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LStrList : TStringList;
  LJsFunc  : string;
begin
  LStrList := TStringList.Create;
  try
    LStrList.LoadFromFile(ExpandFileName('.\Test_JS2.txt'));
    //JavaScript̃R[hZbg
    Chromium1.ExecuteJavaScript(LStrList.Text, 'about:blank');

    //s֐
    //OnConsoleMessageCxgł͂̒lŏ𕪊򂷂
    FJSFuncName := 'get_array';

    //JavaScript̊֐s
    //߂l̏o͐console.log
    LJsFunc := 'console.log(' + FJSFuncName + ' (""))';
    Chromium1.Browser.MainFrame.ExecuteJavaScript(LJsFunc, 'about:blank', 0);
  finally
    FreeAndNil(LStrList);
  end;
end;

//=============================================================================
//  JavaScript̎s
//  FJSFuncName̓O[oϐ
//=============================================================================
procedure TForm1.Button3Click(Sender: TObject);
var
  LCode    : string;
  LJsFunc  : string;
begin
  LCode := 'javascript:'
         + ''
         + 'function get_array () {'
         + 'var list = new Array();'
         + 'list.push(''s'');'
         + 'list.push("\",,{\"");'
         + 'list.push("''s{''");'
         + 'return list;'
         + '}';
  //JavaScript̃R[hZbg
  Chromium1.ExecuteJavaScript(LCode, 'about:blank');

  //s֐
  //OnConsoleMessageCxgł͂̒lŏ𕪊򂷂
  FJSFuncName := 'get_array';

  //JavaScript̊֐s
  //߂l̏o͐console.log
  LJsFunc := 'console.log(' + FJSFuncName + ' (""))';
  Chromium1.Browser.MainFrame.ExecuteJavaScript(LJsFunc, 'about:blank', 0);
end;

//=============================================================================
//  JavaScript̎s
//  FJSFuncName̓O[oϐ
//=============================================================================
procedure TForm1.Button4Click(Sender: TObject);
var
  LCode    : string;
  LJsFunc  : string;
begin
  LCode := 'javascript:'
         + ''
         + 'function get_array () {'
         + 'var list = new Array();'
         + 'list.push(' + Chr(39) + 's' + Chr(39) + ');'
         + 'list.push("\",,{\"");'
         + 'list.push("\' + Chr(39) + 's{\' + Chr(39) +'");'
         + 'return list;'
         + '}';
  //JavaScript̃R[hZbg
  Chromium1.ExecuteJavaScript(LCode, 'about:blank');

  //s֐
  //OnConsoleMessageCxgł͂̒lŏ𕪊򂷂
  FJSFuncName := 'get_array';

  //JavaScript̊֐s
  //߂l̏o͐console.log
  LJsFunc := 'console.log(' + FJSFuncName + ' (""))';
  Chromium1.Browser.MainFrame.ExecuteJavaScript(LJsFunc, 'about:blank', 0);
end;

//=============================================================================
//  JavaScript̎s
//  FJSFuncName̓O[oϐ
//=============================================================================
procedure TForm1.Button5Click(Sender: TObject);
var
  LCode    : string;
  LJsFunc  : string;
begin
  LCode := 'javascript:'
         + ''
         + 'function get_array () {'
         + 'var list = new Array();'
         + 'list.push(' + Chr(39) + 's' + Chr(39) + ');'
         + 'list.push("\",,{\"");'
         + 'list.push("\' + #39 + 's{\' + #39 +'");'
         + 'return list;'
         + '}';
  //JavaScript̃R[hZbg
  Chromium1.ExecuteJavaScript(LCode, 'about:blank');

  //s֐
  //OnConsoleMessageCxgł͂̒lŏ𕪊򂷂
  FJSFuncName := 'get_array';

  //JavaScript̊֐s
  //߂l̏o͐console.log
  LJsFunc := 'console.log(' + FJSFuncName + ' (""))';
  Chromium1.Browser.MainFrame.ExecuteJavaScript(LJsFunc, 'about:blank', 0);
end;

//=============================================================================
//  Chromium1OnConsoleMessageCxg
//  JavaScript̂̊֐̎sʂ̃CxgŎ󂯎
//=============================================================================
procedure TForm1.Chromium1ConsoleMessage(Sender: TObject;
  const browser: ICefBrowser; level: Cardinal; const message, source: ustring;
  line: Integer; out Result: Boolean);
var
  LStrList : TStringList;
begin
  if source = 'about:blank' then begin
    if FJSFuncName = 'get_array' then begin
      LStrList := TStringList.Create;
      try
        LStrList.Delimiter := ',';
        LStrList.StrictDelimiter := True;
        LStrList.DelimitedText := message;
        MessageBox(Handle, PChar(LStrList.Text), '', MB_ICONINFORMATION);
      finally
        FreeAndNil(LStrList);
      end;
    end;
  end;
end;

end.
