//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  Google Chrome uEURg[ CEF4DelphĩeXg
//  Find \bhɂeLXg̒ƃL[Cxg
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  2017N0301 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//  CEF4Delphi 3.3359.1768
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

{$I cef.inc}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, uCEFChromium, ComCtrls, uCEFWindowParent,
  uCEFInterfaces, uCEFTypes, uCEFConstants, AppEvnts;

const
  CHROMIUM_KEYDOWN = WM_APP + $501;

type
  TForm1 = class(TForm)
    CEFWindowParent1: TCEFWindowParent;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Edit1: TEdit;
    Chromium1: TChromium;
    Timer1: TTimer;
    Panel2: TPanel;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Label1: TLabel;
    Edit2: TEdit;
    ApplicationEvents1: TApplicationEvents;    procedure FormCreate(Sender: TObject);
    procedure Chromium1AfterCreated(Sender: TObject;
      const browser: ICefBrowser);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Chromium1Close(Sender: TObject; const browser: ICefBrowser;
      out Result: Boolean);
    procedure Chromium1BeforeClose(Sender: TObject; const browser: ICefBrowser);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Chromium1AddressChange(Sender: TObject;
      const browser: ICefBrowser; const frame: ICefFrame; const url: ustring);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
    procedure Chromium1KeyEvent(Sender: TObject; const browser: ICefBrowser;
      const event: PCefKeyEvent; osEvent: PMsg; out Result: Boolean);
    procedure Chromium1FindResult(Sender: TObject; const browser: ICefBrowser;
      identifier, count: Integer; const selectionRect: PCefRect;
      activeMatchOrdinal: Integer; finalUpdate: Boolean);
    procedure Edit2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private 錾 }
    FCanClose   : boolean;
    FClosing    : boolean;
    procedure BrowserCreatedMsg(var aMessage : TMessage); message CEF_AFTERCREATED;
    procedure BrowserDestroyMsg(var aMessage : TMessage); message CEF_DESTROY;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Text := 'http://mrxray.on.coocan.jp/index.htm';

  Chromium1.CreateBrowser(CEFWindowParent1, '');
  FCanClose := False;
  FClosing  := False;
end;

//-----------------------------------------------------------------------------
//  ȉCtH[̐I܂ł̊֌W
//  CEF4Delphi 3.3359.1768.g8e7c5d6 ݗp
//
//  TTimer̃vpeB͈ȉ̒lɂĂ
//  TTimer.Enabled := False;
//  TTimer.Interval := 300;
//
//  ICefBrowser̃C^[tFCX̎gpɂusesuCEFInterfacesKv
//  萔̎gpɂusesuCEFConstantsKv
//-----------------------------------------------------------------------------
procedure TForm1.Chromium1AfterCreated(Sender: TObject;
  const browser: ICefBrowser);
begin
  PostMessage(Handle, CEF_AFTERCREATED, 0, 0)
end;

//-----------------------------------------------------------------------------
procedure TForm1.BrowserCreatedMsg(var aMessage: TMessage);
begin
  CEFWindowParent1.UpdateSize;
  Chromium1.LoadURL(Trim(Edit1.Text));
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormShow(Sender: TObject);
begin
  //('ł');

  //  WebRTCIP[N
  //  ڍׂ https://www.browserleaks.com/webrtc Q
  Chromium1.WebRTCIPHandlingPolicy := hpDisableNonProxiedUDP;
  Chromium1.WebRTCMultipleRoutes   := STATE_DISABLED;
  Chromium1.WebRTCNonproxiedUDP    := STATE_DISABLED;

  //ĂȂꍇ̓^C}[gpČŃuEU𐶐
  if not(Chromium1.CreateBrowser(CEFWindowParent1, '')) then Timer1.Enabled := True;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := FCanClose;

  if not(FClosing) then begin
    FClosing := True;
    Visible  := False;
    Chromium1.CloseBrowser(True);
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
//
end;

//-----------------------------------------------------------------------------
procedure TForm1.Chromium1BeforeClose(Sender: TObject;
  const browser: ICefBrowser);
begin
  if (Chromium1.BrowserId = 0) then begin
    FCanClose := True;
    PostMessage(Handle, WM_CLOSE, 0, 0);
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Chromium1Close(Sender: TObject; const browser: ICefBrowser;
  out Result: Boolean);
begin
  if (browser <> nil) and (Chromium1.BrowserId = browser.Identifier) then begin
    PostMessage(Handle, CEF_DESTROY, 0, 0);
    Result := True;
  end else begin
    Result := False;
  end;
end;

//-----------------------------------------------------------------------------
procedure TForm1.BrowserDestroyMsg(var aMessage: TMessage);
begin
  CEFWindowParent1.Free;
end;

//-----------------------------------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  if not(Chromium1.CreateBrowser(CEFWindowParent1, ''))
    and not(Chromium1.Initialized) then begin
    Timer1.Enabled := True;
  end;
end;
//-----------------------------------------------------------------------------
//  tH[ƏȈ֌WR[hD܂
//-----------------------------------------------------------------------------


//=============================================================================
//  Chromium1OnAddressChangeCxg
//  ύXꂽEFuy[W̃AhXEdit1ɕ\
//=============================================================================
procedure TForm1.Chromium1AddressChange(Sender: TObject;
  const browser: ICefBrowser; const frame: ICefFrame; const url: ustring);
begin
  Edit1.Text := url;
end;

//=============================================================================
//  Edit1OnKeyDownCxg
//  [Enter]L[Edit1URL\
//=============================================================================
procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    Chromium1.LoadURL(Trim(Edit1.Text));
  end;
end;

//=============================================================================
//  Õy[WɈړ
//=============================================================================
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Chromium1.GoBack;
end;

//=============================================================================
//  Chromium1OnKeyEventCxg
//
//  ̃CxgłŃCvZX̃Rg[ɑ΂đ삵Ȃ
//  CvZX̃Rg[ɑ΂đ삷ƃnOAbv
//=============================================================================
procedure TForm1.Chromium1KeyEvent(Sender: TObject; const browser: ICefBrowser;
  const event: PCefKeyEvent; osEvent: PMsg; out Result: Boolean);
var
  LMsg : TMsg;
begin
  Result := False;

  if not(Chromium1.IsSameBrowser(browser)) then exit;
  if (event = nil) or (osEvent = nil) then Exit;

  if osEvent.Message = WM_KEYDOWN then begin
    LMsg := osEvent^;
    //C̃vZXɃbZ[W𑗐M
    //{Tvł͂̃bZ[WTApplicationEvents.OnMessageŎ󂯎
    PostMessage(Handle, CHROMIUM_KEYDOWN, LMsg.wParam, LMsg.lParam);

    Result := True;
  end;
end;

//=============================================================================
//  ApplicationEvents1OnMessageCxg
//  Chromium1OnKeyEventCxg̃bZ[W󂯎ď
//=============================================================================
procedure TForm1.ApplicationEvents1Message(var Msg: tagMSG;
  var Handled: Boolean);
var
  LKeyState : TKeyboardState;
  LIsCtrl   : Boolean;
  LIsShift  : Boolean;
begin
  if (Msg.message = CHROMIUM_KEYDOWN) or (Msg.message = WM_KEYDOWN) then begin
    LIsCtrl := False;
    if GetKeyboardState(LKeyState) then begin
      LIsCtrl  := LKeyState[VK_CONTROL] and $80 <> 0;
      LIsShift := LKeyState[VK_SHIFT] and $80 <> 0;
    end;
    //[Ctrl]L[܂܂Ă猟pTPanel\ČJn
    if (Msg.wParam = Ord('F')) and LIsCtrl then begin
      Panel2.Visible := True;
      SpeedButton3Click(nil);
      Edit2.SetFocus;
    end else
    if (Msg.wParam = VK_F3) and (Panel2.Visible) and LIsShift then begin
      SpeedButton2Click(nil);
    end else
    if (Msg.wParam = VK_F3) and (Panel2.Visible) then begin
      SpeedButton3Click(nil);
    end;
  end;
end;

//=============================================================================
//  p͂̕TEditOnKeyDownCxg
//  [Enter]L[ŌJn
//=============================================================================
procedure TForm1.Edit2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then begin
    SpeedButton3Click(nil);
  end;
end;

//=============================================================================
//  O()
//=============================================================================
procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Chromium1.Find(1, Edit2.Text, False, False, True);
end;

//=============================================================================
//  ()
//=============================================================================
procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if Trim(Edit2.Text) = '' then begin
    Label1.Caption := '';
    SpeedButton2.Enabled := False;
    SpeedButton3.Enabled := False;
  end else begin
    Chromium1.Find(1, Edit2.Text, True, False, False);
  end;
end;

//=============================================================================
//  I
//=============================================================================
procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  Chromium1.StopFinding(True);
  //pTPanel\ɂ
  Panel2.Visible := False;
end;

//=============================================================================
//  Chromium1OnFindResultCxg
//  ̌ʁCqbg\
//=============================================================================
procedure TForm1.Chromium1FindResult(Sender: TObject;
  const browser: ICefBrowser; identifier, count: Integer;
  const selectionRect: PCefRect; activeMatchOrdinal: Integer;
  finalUpdate: Boolean);
begin
  Label1.Caption := IntToStr(count) + '  ' + IntToStr(activeMatchOrdinal) + ' ';
  SpeedButton2.Enabled := count >= 1;
  SpeedButton3.Enabled := count >= 1;
end;

end.
